Bug 473473 - new move_mount behavior breaks davfs
new move_mount behavior breaks davfs
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: autofs (Show other bugs)
11
x86_64 Linux
medium Severity high
: ---
: ---
Assigned To: Ian Kent
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-28 13:26 EST by Carl Roth
Modified: 2010-06-28 06:50 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 06:50:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
syslog entries from autofs (2.17 KB, text/plain)
2008-11-29 13:21 EST, Carl Roth
no flags Details

  None (edit)
Description Carl Roth 2008-11-28 13:26:38 EST
Description of problem:

autofs as of 5.0.3-27 no longer works with davfs (dav.sourceforge.net).  The new behavior is

* autofs calls mount.davfs with mount arguments
* initial mount request succeeds
* a few seconds later, mount.davfs exits
* directory access fails with 'endpoint not connected'

Version-Release number of selected component (if applicable):

autofs-5.0.3-33.x86_64 (behavior started with -27)

How reproducible:

Always

Steps to Reproduce:
1. Create an autofs mount point entry for a davfs 
2. access the directory (e.g. 'ls')
3. wait a few seconds
4. access the directory again
  
Actual results:

directory is un-mounted and further accesses fail

Expected results:

directory should stay mounted

Additional info:

From what I can tell, the new behavior that is interfering with davfs is the 'move_mount' call ('/bin/mount --move') in autofs.  The davfs mounter computes credentials, cache directories, etc. based on source *and* destination paths, and doesn't permit the destination path to change after the initial mount.  The davfs mount itself fails silently; I suspect it happens when it performs a simple scan of /proc/mounts to make sure its mount point is still valid (unchanged).

Relevant issue is at

  https://sourceforge.net/tracker2/?func=detail&aid=2351688&group_id=26275&atid=386749
Comment 1 Ian Kent 2008-11-28 23:36:21 EST
Provide your maps and a debug log.
See http://people.redhat.com for details.
Comment 2 Carl Roth 2008-11-29 13:21:03 EST
Here is a relevant line from /etc/auto.master:

/dav /etc/auto.dav

Here is part of /etc/auto.dav:

yona.ursus.net -fstype=davfs,rw,nosuid,nodev \
        /dav/users/roth -uid=roth,gid=roth https\://&/dav/users/roth

I'm attach a syslog with relevant entries from autofs (set LOGGING=debug in /etc/sysconfig/autofs).
Comment 3 Carl Roth 2008-11-29 13:21:39 EST
Created attachment 325100 [details]
syslog entries from autofs
Comment 4 Ian Kent 2008-11-29 21:47:14 EST
(In reply to comment #2)
> Here is a relevant line from /etc/auto.master:
> 
> /dav /etc/auto.dav
> 
> Here is part of /etc/auto.dav:
> 
> yona.ursus.net -fstype=davfs,rw,nosuid,nodev \
>         /dav/users/roth -uid=roth,gid=roth https\://&/dav/users/roth
> 

OK, this map entry shouldn't need to be prepared in another
location and so shouldn't need to be moved. I'll have a look
and see what's going on.
Comment 5 Ian Kent 2008-11-29 21:51:43 EST
(In reply to comment #3)
> Created an attachment (id=325100) [details]
> syslog entries from autofs

But I can see from the log that the map you have quoted above
isn't quite what your actually using. There is not point
whatsoever in posting something that isn't what your using if
you expect this request to be taken seriously.

What is your map configuration?
Comment 6 Ian Kent 2008-11-29 21:53:19 EST
(In reply to comment #5)
> (In reply to comment #3)
> > Created an attachment (id=325100) [details] [details]
> > syslog entries from autofs
> 
> But I can see from the log that the map you have quoted above
> isn't quite what your actually using. There is not point
> whatsoever in posting something that isn't what your using if
> you expect this request to be taken seriously.
> 
> What is your map configuration?

Oh .. hang on, I take that back, that could be the map entry.

Let me thing about this for a while.
Comment 7 Ian Kent 2008-11-29 22:00:57 EST
(In reply to comment #4)
> (In reply to comment #2)
> > Here is a relevant line from /etc/auto.master:
> > 
> > /dav /etc/auto.dav
> > 
> > Here is part of /etc/auto.dav:
> > 
> > yona.ursus.net -fstype=davfs,rw,nosuid,nodev \
> >         /dav/users/roth -uid=roth,gid=roth https\://&/dav/users/roth
> > 
> 
> OK, this map entry shouldn't need to be prepared in another
> location and so shouldn't need to be moved. I'll have a look
> and see what's going on.

I see this statement isn't correct now that I've looked more
closely at this entry. While this entry itself doesn't require
preparation elsewhere multi-mounts with offsets often do in
order to prevent other processes from walking into them during
the mount. A situation you probably don't see but it can happen.
Comment 8 Ian Kent 2008-12-01 01:12:52 EST
(In reply to comment #0)
> 
> Relevant issue is at
> 
>  
> https://sourceforge.net/tracker2/?func=detail&aid=2351688&group_id=26275&atid=386749

I see there is a patch for davfs now.
While I should be able to provide a patch for autofs for the
specific case your seeing here I can't do this to cover multi-
mounts generally because of the potential issue of processes
walking into an incomplete mount tree. Is the davfs patch
adequate?
Comment 9 Carl Roth 2008-12-01 11:40:17 EST
(In reply to comment #8)
> (In reply to comment #0)
> > 
> > Relevant issue is at
> > 
> >  
> > https://sourceforge.net/tracker2/?func=detail&aid=2351688&group_id=26275&atid=386749
> 
> I see there is a patch for davfs now.
> While I should be able to provide a patch for autofs for the
> specific case your seeing here I can't do this to cover multi-
> mounts generally because of the potential issue of processes
> walking into an incomplete mount tree. Is the davfs patch
> adequate?

No, my simple-minded patch doesn't work:

* the patch only fixes the initial davfs configuration parser
* davfs cannot cope at runtime with 'mount --move'
* davfs cache files become inconsistent since they are keyed using source and destination paths

I did try the same experiment with another fuse-enabled filesystem (sshfs).  In that case, 'mount --move' does not cause the mount to fail or exit; I am not sure if it affects the caching behavior negatively though.
Comment 10 Bug Zapper 2009-06-09 23:22:35 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Bug Zapper 2009-11-18 03:00:04 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 12 Bug Zapper 2010-04-27 08:23:29 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 13 Bug Zapper 2010-06-28 06:50:41 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.